--- old/usr/src/lib/libdisasm/common/dis_arm.c	2015-01-14 19:07:05.231790738 -0500
+++ new/usr/src/lib/libdisasm/common/dis_arm.c	2015-01-14 19:07:05.239244606 -0500
@@ -808,11 +808,17 @@
 	 * Print the shifter as appropriate
 	 */
 	switch (dpi_inst.dpii_stype) {
-	case ARM_DPI_SHIFTER_IMM32:
-		len = snprintf(buf, buflen, ", #%d, %d",
-		    dpi_inst.dpii_un.dpii_im.dpisi_imm,
-		    dpi_inst.dpii_un.dpii_im.dpisi_rot);
+	case ARM_DPI_SHIFTER_IMM32: {
+		uint32_t imm = dpi_inst.dpii_un.dpii_im.dpisi_imm;
+		int rot = dpi_inst.dpii_un.dpii_im.dpisi_rot * 2;
+		if (rot != 0)
+			imm = (imm << (32 - rot)) | (imm >> rot);
+		if (imm < 10)
+			len = snprintf(buf, buflen, ", #%d", imm);
+		else
+			len = snprintf(buf, buflen, ", #%d  ; %#x", imm, imm);
 		break;
+	}
 	case ARM_DPI_SHIFTER_SIMM:
 		if (dpi_inst.dpii_un.dpii_si.dpiss_code == DPI_S_NONE) {
 			len = snprintf(buf, buflen, ", %s",
